//    Copyright (C) 2003 Chad Brassil
//    This file is part of NFP.
//
//    NFP is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Foobar is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <PalmOS.h>
#include <SonyTypes.h>
#include <SonySystemPublic.h>
#include <SonyHRLib.h>
#include <SysEvtMgr.h>

#include "NFP.h"
#include "NFPRsc.h"
//#include "DateMonth_res.h"
 
#define PopUpLeftX		31
#define PopUpLeftY		15 //17 //144

static RectangleType rP;
static RectangleType rCervix;
static RectangleType rSensation;
static RectangleType rColor;
static RectangleType rPhase;
static DateType chartStartDate;
//static UInt8 dayWidth;
static Boolean plusMore;
static Boolean minusMore; 
static /*const*/ CustomPatternType pat = {85,170,85,170,85,170,85,170}; //needed to remove const for prc-tools
static UInt8 phaseStor[29];
static UInt8 heartStor[29];
static UInt8 scrollNumber;

//static void SECT4 DebugNum(Int32 number)
//{
//	Char str[20];
//	Char *pStr;
//	
//	pStr = &str[0];
//
//	StrPrintF(pStr,"%i",number);
//	ErrDisplay(pStr);
//
//}


/*
static void CycleTroubleshoot()
{
	UInt16 cycleIndex = 0;
	CycleRecord* cycle;


	cycle = CycleQueryCycle(cycleIndex);
	while(cycle)
	{
		CycleReleaseCycle();
		cycleIndex++;
		cycle = CycleQueryCycle(cycleIndex);
	}
	
	return;
}
*/

static void SECT4 ChartInit(void)
{
	UInt16 objIndex;;
	FormType* frmP;
	
	plusMore = false;
	minusMore = false;
	chartStartDate.year = 0; //if this remains 0, then there is no cycle

	//set gadgets to ObjectFill because they are selectable
	if(colorEnabled)
		WinSetBackColor(UIColorGetTableEntryIndex(UIObjectFill));

	frmP = FrmGetActiveForm();
	
	objIndex = FrmGetObjectIndex (frmP, TempChartChartGadget);
	FrmGetObjectBounds (frmP, objIndex, &rP);
	WinEraseRectangle (&rP, 0);
	
	objIndex = FrmGetObjectIndex (frmP, TempChartCervixGadget);
	FrmGetObjectBounds (frmP, objIndex, &rCervix);
	WinEraseRectangle (&rCervix, 0);
	
	objIndex = FrmGetObjectIndex (frmP, TempChartFluidSensationGadget);
	FrmGetObjectBounds (frmP, objIndex, &rSensation);
	WinEraseRectangle (&rSensation, 0);
	
	objIndex = FrmGetObjectIndex (frmP, TempChartFluidColorGadget);
	FrmGetObjectBounds (frmP, objIndex, &rColor);
	WinEraseRectangle (&rColor, 0);
	
	objIndex = FrmGetObjectIndex (frmP, TempChartIndicatorGadget);
	FrmGetObjectBounds (frmP, objIndex, &rPhase);
	WinEraseRectangle (&rPhase, 0);
	
	WinSetPattern(&pat);
	
	WinDrawLine(0, rP.topLeft.y + rP.extent.y - 2, 160, rP.topLeft.y + rP.extent.y - 2);
	
	if(g_prefs.fluidIndicator==1)//Marquette model
	{
		objIndex = FrmGetObjectIndex(frmP,TempChartFCLabel);
		FrmHideObject(frmP,objIndex);
		FrmCopyLabel(frmP,TempChartFSLabel,"M");
	}
	
	if(g_prefs.chartDisplay==1 && g_prefs.hormoneTest==0)//display LH Test
		FrmCopyLabel(frmP,TempChartCxLabel,"LH");
		
	if(g_prefs.chartDisplay==1 && g_prefs.hormoneTest==1)//display clearplan
		FrmCopyLabel(frmP,TempChartCxLabel,"Cp");
		
	return;
}

static Boolean SECT4 TempChartFormInit(FormType * frmP, UInt16* cycleIndex )
{
	Int32 dayDiff;
	Int32 lastDiff;
	Int16 tempNumber;
	float tempFloat;
	Boolean isOldCycle;
	Boolean dataExists;
	ControlType* ctlP;
	CycleRecord* cycle;
	UInt16 itemIndex;
	NFPDBRecord* item;
	DateType lastDate;
	Int16 numberOfCycles;
	UInt16 objectIndex;
	Char *pString;
	DateType today;
	Int16 cycleDay;
	UInt16 index;
	Boolean isOldRecord;
	Boolean beyondMaxIndex;
	Err err;
	
	scrollNumber = 0; //set to beginning of cycle at first
	//set to temp pref so remembers to come back to this form
	temp_prefs.view = 2;
	
	*cycleIndex = s_lastCycleIndex;
	
	isOldCycle = FindCycleFromDate(s_currentDate,cycleIndex,&dataExists);
	
	numberOfCycles = CycleGetCount() - 1;
	//if last cycle disable next arrow
	//or if no cycles exist
	if( *cycleIndex == UInt16(numberOfCycles) || numberOfCycles < 0 )
	{
		GetObjectPtr(ctlP,TempChartNextMonthRepeating);
		CtlHideControl(ctlP);
	}
	
	//if first cycle disable previous arrow
	if(*cycleIndex == 0)
	{
		GetObjectPtr(ctlP,TempChartPrevMonthRepeating);
		CtlHideControl(ctlP);
	}
	
	//adjust scroll number so that currentDate is in the view
	//get startdate, and compare to current Date
	//however, don't increase more than needed to show last data point in cycle

	cycle = CycleQueryCycle(*cycleIndex);
	if(cycle)
	{
		//get date of last data date in cycle
		//if last cycle, then last data entry
		if(CycleGetCount() == *cycleIndex + 1)
			itemIndex = DataGetCount() - 1;	//should be -1	
		else
		//otherwise, find start date of next cycle, find item for that
		// start date, and backup one itemIndex
		{
			CycleReleaseCycle();
			cycle = CycleQueryCycle(*cycleIndex + 1);
			itemIndex = s_currentRecordNumber; //added this line because I think I need it, otherwise I haven't passed a starting position
		
			FindRecordFromDate(cycle->cycleStart,&itemIndex,NULL,NULL);
			
			if(itemIndex>0) itemIndex--; //although should always be > 0
		
			CycleReleaseCycle();
			cycle = CycleQueryCycle(*cycleIndex);		
		}
		
		//then set currentDate to smaller of currentDate or last DataEntry date
		item = DataQueryData(itemIndex);
		if(DateTypeCmp(item->recDate,s_currentDate) < 0)
			s_currentDate = item->recDate;
		lastDate = item->recDate;
		DataReleaseData();

		//adjust scroll number so that currentDate is in the view
		//get startdate, and compare to current Date			
		dayDiff = DateToDays(s_currentDate)-DateToDays(cycle->cycleStart);
		tempFloat = float((dayDiff - 28.0)/6.0 + 1.0);
		tempNumber = Int16(tempFloat);

		//check to be sure there is actually more data beyond 		
		if(tempNumber == tempFloat)
		{
			lastDiff = DateToDays(lastDate)-DateToDays(cycle->cycleStart);
			if(lastDiff == dayDiff)
				tempNumber--;
		}
		
		if(tempNumber>=0)
			scrollNumber = tempNumber;
		else
			scrollNumber = 0;
		CycleReleaseCycle();
	}
	
	//set push button
	FrmSetControlGroupSelection(frmP,1,TempChartChartViewPushButton);
	
	//set Today
	DateSecondsToDate (TimGetSeconds (), &today);
	//do this to determine the cycle day
	index = DataGetCount(); //start at last record
	if(index > 0)
		index--;
	isOldRecord = FindRecordFromDate(today, &index, &dataExists, &beyondMaxIndex);
	DeterminePhase(today, index, isOldRecord, dataExists, beyondMaxIndex, &cycleDay, true, NULL);

	//set Today label
	objectIndex = FrmGetObjectIndex(frmP,TempChartTodayLabel);
	FrmHideObject(frmP,objectIndex);
	pString = (Char*)MemPtrNew(maxStrIToALen);
	if(cycleDay != -1)
		StrIToA(pString,cycleDay);
	else
		StrCopy(pString,"");	
	FrmCopyLabel(frmP,TempChartTodayLabel,pString);
	err = MemPtrFree(pString);
	FrmShowObject(frmP,objectIndex); 
	
	return isOldCycle;
}

static void SECT4 TempChartFormClose(FormType * frmP)
{

}

Boolean TempChartFormHandleEvent(EventType * eventP)
{
    Boolean handled = false;
    FormType * frmP;
    Boolean isOldCycle = false;
    Boolean dataExists = true;
    UInt16 cycleIndex = 0;
    DateType date;
    DateType today;
    Int16 scroll = 0;
    CycleRecord* cycle;
//    const Char *title;

    switch (eventP->eType) 
        {
        case frmOpenEvent:
            frmP = FrmGetActiveForm();
            isOldCycle = TempChartFormInit(frmP,&cycleIndex);
            FrmDrawForm(frmP);
            cycle = CycleQueryCycle(cycleIndex);
			if(!cycle)
    	   		//display message explaining why no data is being displayed	
				FrmAlert(NoCyclesAlert);
			else
				CycleReleaseCycle();
            PlotTemps(cycleIndex,isOldCycle,scrollNumber);
            //CycleTroubleshoot();
          
            handled = true;
            break;
                         
        case frmUpdateEvent:
            frmP = FrmGetActiveForm();
            FrmDrawForm(frmP);
            //need to get cycleIndex again, otherwise just uses 0
           	cycleIndex = s_lastCycleIndex;
			isOldCycle = FindCycleFromDate(s_currentDate,&cycleIndex,&dataExists);
            PlotTemps(cycleIndex,isOldCycle,scrollNumber);
       
            handled = true;
            break;

		case menuEvent:
			handled = MainFormDoCommand (eventP->data.menu.itemID);
			break;
			
		case ctlEnterEvent:
			switch (eventP->data.ctlRepeat.controlID)
			{
				case TempChartPrevMonthRepeating:
        			ChartChangeCycle(-1);
        		    handled = true;
					break;
			
				case TempChartNextMonthRepeating:
	        		ChartChangeCycle(1);
        		    handled = true;
					break;
			}
			break;

		case penDownEvent:
			if(ChartSelectDay(eventP,&date,&scroll))
			{
				if(scroll==0)
				{
					DateSecondsToDate(TimGetSeconds(),&today);	//get today	
					if( DateTypeCmp(today,date) >= 0 )
					{
						s_currentDate = date;
						FrmGotoForm (DataEntryForm);			
					}
					else
					{
				        FrmAlert(NoFutureAlert);
					}
					handled = true;
				}
				else
				{
					scrollNumber+=scroll;
					FrmUpdateForm(TempChartForm,0);
				}
				
			}
			break;
            
        case ctlSelectEvent:
	        switch (eventP->data.ctlSelect.controlID)
	       	{
				case TempChartMonthSquarePushButton:
					FrmGotoForm(MonthViewForm);
					handled = true;
					break;
				
				case TempChartTodayViewPushButton:
			 		//set to today
					DateSecondsToDate (TimGetSeconds (), &s_currentDate);
			    	FrmGotoForm(DataEntryForm);
					handled = true;
					break;		
			}
			break;

		case keyDownEvent:
        	//may need to add TxtGlueCharlsVirtual to restrict this
        	//to virtual characters only
        	switch (eventP->data.keyDown.chr)
        	{
        		case vchrPageUp:
        			ChartChangeCycle(-1);
        		    handled = true;
        			break;        		
        		
        		case vchrPageDown:
             		ChartChangeCycle(1);
        		    handled = true;
        			break;

        		default:
        			break;
        	}
        	break;

			
		case frmCloseEvent:
   			//manages data saving and deleting
   			frmP = FrmGetActiveForm();
   			TempChartFormClose(frmP);
		
			break;

        default:
            break;
        }
    
    return handled;
}


static void SECT4 SetLabel (UInt16 objID, Char* pString, UInt8 atLeastOneTemp )
{
	FormType *frmP;
	UInt16 objectIndex;

	//Change label on form
	frmP = FrmGetActiveForm();
	objectIndex = FrmGetObjectIndex(frmP,objID);
	FrmHideObject(frmP,objectIndex);

	if(atLeastOneTemp)
		FrmCopyLabel(frmP,objID,pString);
	else
		FrmCopyLabel(frmP,objID,"");
	FrmShowObject(frmP,objectIndex);

	return;
}


//y is not really used in this function
static void SECT4 DrawPhase(UInt8 x, UInt8 y, UInt8 phase)
{
	FontID oldFont;
	Char *phaseLabels;
	Char *label;
	MemHandle h1;
	RectangleType fullDay;
	
	oldFont = FntSetFont (stdFont);
	
	h1 = DmGetResource (strRsc, PhaseLabelsString);
	phaseLabels = (Char*)MemHandleLock (h1);
	
	y = rPhase.topLeft.y;
	x = x + rPhase.topLeft.x;
	
	switch(phase)
	{
		case 0:
			break;
		case 1:
		//	label = &phaseLabels[0];
		//	WinDrawChars(label,1,x-1,y);
			break;
		case 2:
			label = &phaseLabels[1];
			WinDrawChars(label,1,x + 2,y);
			break;
		case 3:
			label = &phaseLabels[2];
			WinDrawChars(label,1,x + 1,y);
			break;
		case 4:
			label = &phaseLabels[3];
			WinDrawChars(label,1,x + 1,y);
			break;
		case 5:
			label = &phaseLabels[4];
			WinDrawChars(label,1,x + 2,y);
			break;
		case 6:
			label = &phaseLabels[5];
			WinDrawChars(label,1,x,y);
			break;						
		default:
			break;
	}
	
	MemPtrUnlock(phaseLabels);
	DmReleaseResource(h1);
	FntSetFont(oldFont);
	
	fullDay.topLeft.x = x;
	fullDay.topLeft.y = rP.topLeft.y;
	fullDay.extent.y = rPhase.topLeft.y + rPhase.extent.y  - rP.topLeft.y;
	fullDay.extent.x = dayWidth;
	
	DrawDayColor (&fullDay, phase);

	return;
}


static void SECT4 DrawBar(UInt8 x, UInt8 y, RectangleType *rChoice, UInt8 color )
{
	RectangleType draw;

	//flip over and add top margin
	draw.extent.x  = 5;
	draw.extent.y  = y - 1;
	draw.topLeft.x = x + rChoice->topLeft.x;
	
	if(color == 1) //black from bottom
	{
		draw.topLeft.y = rChoice->topLeft.y + rChoice->extent.y - y ;
		//using current foreground color, so could change foreground color
		//need to get color support info
		WinDrawRectangle(&draw,0);
	}
	else if (color == 2) //grey from top
	{
		draw.topLeft.y = rChoice->topLeft.y;
//		WinFillRectangle(&draw,0);
//		WinDrawRectangle(&draw,0);
		WinFillRectangle(&draw,0);
	}

	
	return;
}

static void SECT4 DrawDot(UInt8 x, UInt8 y,UInt8 dotType,UInt8 phase)
{
	MemHandle h1;
	MemHandle h2;
	BitmapType *closedDot;
 	BitmapType *openDot;
	RGBColorType 	color;
	UInt16 refNum;
	
	if(!dotType)
		return;
	
	//flip over and add top margin
	y = rP.extent.y - y + rP.topLeft.y - 5 - 3; //subtract pixels of bitmap and three more for edge buffer
	
	x = x + rP.topLeft.x;
	
	if(hrEnabled)
	{
		SysLibFind(sonySysLibNameHR, &refNum);
		h1 = DmGetResource (bitmapRsc, HROpenDotBitmapFamily);
		h2 = DmGetResource (bitmapRsc, HRClosedDotBitmapFamily);
	}
	else
	{
		h1 = DmGetResource (bitmapRsc, OpenDotBitmapFamily);
		h2 = DmGetResource (bitmapRsc, ClosedDotBitmapFamily);
	}
	
	openDot = (BitmapType*)MemHandleLock (h1);
	closedDot = (BitmapType*)MemHandleLock (h2);
	
	if(colorEnabled)
	{
		color = PhaseColor (phase);
		WinSetBackColor(WinRGBToIndex(&color));
	}
	
	switch(dotType)
	{
		case 0:
			break;

		case 1:
			if(hrEnabled)
				HRWinDrawBitmap(refNum,closedDot,2*x,2*y);
			else
				WinDrawBitmap (closedDot,x,y);
			break;

		case 2:
			if(hrEnabled)
				HRWinDrawBitmap(refNum,openDot,2*x,2*y);
			else
				WinDrawBitmap (openDot,x,y);
			break;
	
		default:
			break;
	}
	
	if(colorEnabled)
		WinSetBackColor(UIColorGetTableEntryIndex(UIObjectFill));
	
	MemPtrUnlock(openDot);
	MemPtrUnlock(closedDot);
	DmReleaseResource(h1);
	DmReleaseResource(h2);
	
	return;
}


static void SECT4 DrawCoverline(DateType coverlineStartDate, Int8 coverlineLength, Int8 coverlineTemp, DateType chartStartDate, Int8 minTemp, float tempHeight)
{
	UInt8 x1;
	UInt8 y1;
	UInt8 x2;
	UInt8 y2;
	Int16 currentDiff;
	Int16 theoreticalLength;

	
	if(coverlineLength != 0)
	{
	
		if(colorEnabled)
		{
			WinSetForeColor(UIColorGetTableEntryIndex(UIFormFrame));
		}
	
	//first calculate height
		if(coverlineTemp >= 0)
		{
			y1 = (UInt8)((coverlineTemp - minTemp)*tempHeight);
		}
		else //drop a half temp because it is negative
		{
			y1 = (UInt8)((-coverlineTemp - minTemp - 0.5)*tempHeight);
		}

		//flip over and add top margin
		y1 = rP.extent.y - y1 + rP.topLeft.y - 3 - 3; //subtract half pixels of bitmap and subtract three more for edge buffer

		y2 = y1;
		
		if(minusMore)
			currentDiff = (DateToDays(coverlineStartDate) - DateToDays(chartStartDate) - 1)*dayWidth;			
		else
			currentDiff = (DateToDays(coverlineStartDate) - DateToDays(chartStartDate))*dayWidth;

		theoreticalLength = currentDiff + coverlineLength*dayWidth;

		if(theoreticalLength < 0)
			theoreticalLength = 0;
		if (currentDiff < 0)
			currentDiff = 0;
		if(minusMore)
		{
			x1 = currentDiff + rP.topLeft.x + dayWidth;
			x2 = theoreticalLength + rP.topLeft.x - 1 + dayWidth; //subtract 1 so it doesn't bleed into next date
		}
		else
		{
			x1 = currentDiff + rP.topLeft.x;
			x2 = theoreticalLength + rP.topLeft.x - 1; //subtract 1 so it doesn't bleed into next date
		}
		
		if(plusMore)
		{
			if( x2 > (30*dayWidth + 1))
				x2 = 30*dayWidth + 1;
			if( x1 > (30*dayWidth))
				x1 = x2 + 1; //so it won't plot
		}
	
		if((x2 + 1) - x1 != 0)
			WinDrawLine (x1, y1, x2, y2);


		if(colorEnabled)
			WinSetForeColor(UIColorGetTableEntryIndex(UIFieldText));
	}	
	return;
}


void PlotTemps(UInt16 cycleIndex,Boolean isOldCycle,UInt8 scrollNumber)
{
	Int32 dayDiff;
	Int32 currentDiff;
	Int16 phaseFill;
	DateType phaseDate;
	Boolean nextCycleExists;
	CycleRecord* cycle;
	NFPDBRecord* item;
//	DateType chartStartDate;
	DateType nextCycleStart;
	DateType focalDate;
	DateType today;
	Int16 tempAdjust;
	UInt16 itemIndex;
//	UInt8 dayWidth;
	Int8 maxTemp;
	Int8 minTemp;
	UInt8 maxTempPossible;
	float tempHeight;
	UInt8 prevX;
	UInt8 prevY;
	Boolean prevOpenDotToDraw;
	UInt8 prevPhase = 0; //eliminates a prc-tools warning
	Boolean thisOpenDotToDraw;
	UInt8 x;
	UInt8 y = 0; //eliminates a prc-tools warning
	Char* pString;
	Char* pTempString;
	Err err;
	UInt8 phase;
	FontID oldFont;
	UInt8 value;
	FormType* frmP;
	FontID 			origFont;
	NumberFormatType numFormat;
	UInt8 atLeastOneTemp = 0;//default to 0 = false
	
	if(colorEnabled)
	{
		WinPushDrawState();
		WinSetBackColor(UIColorGetTableEntryIndex(UIFormFill));
		WinSetForeColor(UIColorGetTableEntryIndex(UIObjectForeground));
		WinSetTextColor(UIColorGetTableEntryIndex(UIObjectForeground));
		
	}
	origFont = FntSetFont (boldFont);
	
	ChartInit();
	
	if(g_prefs.tempUnits==1)
		maxTempPossible = numberOfFahrenheitTemps;
	else
		maxTempPossible = numberOfCelsiusTemps;
	
	nextCycleStart.year = 1000;
	maxTemp = 1;  //set to opposite extremes
	minTemp = maxTempPossible; //set to opposite extremes
	
	cycle = CycleQueryCycle(cycleIndex);
	if(!cycle)
	{
		//FntSetFont (origFont);
		if(colorEnabled)
			WinPopDrawState ();	
		return; //quit because a cycle has not been established
	}
	
	chartStartDate = cycle->cycleStart;
	CycleReleaseCycle();

	//set back to FormFill for date
	if(colorEnabled)
		WinSetBackColor(UIColorGetTableEntryIndex(UIFormFill));
	
	//Change label on form
	pString = (Char*)MemPtrNew(longDateStrLength);
	DateToAscii(chartStartDate.month, chartStartDate.day, chartStartDate.year + 1904, (DateFormatType)PrefGetPreference(prefLongDateFormat), pString);//dfMDYLongWithComma
	SetLabel(TempChartStartDateLabel,pString, 1);
	err = MemPtrFree(pString);

	//changed this to a define
	//just set dayWidth = 5
	//dayWidth = 5;
	
		
	//find out max and min temp in this cycle
	itemIndex = s_currentRecordNumber;
	FindRecordFromDate(chartStartDate, &itemIndex, NULL, NULL);
	while(true)
	{
		item = DataQueryData(itemIndex);
		if(!item)
			break;
		if(DateTypeCmp(item->recDate,nextCycleStart)==0)
			{
				DataReleaseData();
				break;
			}
			
		if( item->basalTemp !=0 ) 
			{	
				atLeastOneTemp = 1; //true
				
				if(g_prefs.timeAdjustMode == 0 || g_prefs.timeAdjustMode == 1)
				{
					//time adjustments of 1/10 F per half hour
					tempAdjust = item->time - 4; //so that entry of 4 is 0 adjustment
					if(g_prefs.timeAdjustMode == 1 && g_prefs.tempUnits==1) //half rate in F
						//change time adjustments to 1/10 F per hour
						tempAdjust = tempAdjust/2;	
					if(g_prefs.tempUnits==2) //if in C, then 1/10 C per hour
						tempAdjust = tempAdjust/2;
				}
				else
					tempAdjust = 0;
				
				//check for max and min in actual and adjusted temps
				if( item->basalTemp - tempAdjust < minTemp )
					minTemp = item->basalTemp - tempAdjust;
				if( item->basalTemp < minTemp )
					minTemp = item->basalTemp;
				if( item->basalTemp - tempAdjust > maxTemp )
					maxTemp = item->basalTemp - tempAdjust;
				if( item->basalTemp > maxTemp )
					maxTemp = item->basalTemp;
			}
		
		DataReleaseData();		
		itemIndex++;
	}
	
	//check to be sure maxTemp doesn't exceed the limit
	if(maxTemp > maxTempPossible )
		maxTemp = maxTempPossible;
	//if(minTemp < 0)  //originally, I cut this off at zero, but this caused odd behavior with time offset and min temps
	//	minTemp = 0; //therefore, better to let it be negative and just block display of label
		
	
	//set y-axis range
	//try to stretch by one so that not at edges
	if(minTemp > 1) minTemp--; 
	if(maxTemp < maxTempPossible) maxTemp++;
	
	//be sure at least 5
	while(maxTemp-minTemp < 5)
	{
		if(minTemp > 1) minTemp--;
		if(maxTemp < maxTempPossible) maxTemp++;
	}
	
	//finally be sure odd so there is a middle temp
	if( float((maxTemp-minTemp + 1)/2.0)==Int16((maxTemp-minTemp + 1)/2) ) //even so add one
	{
		if(maxTemp < maxTempPossible)
			maxTemp++;
		else if(minTemp > 1)
			minTemp--;
		else		//at extremes already and even, try to avoid this by insuring an odd range
			maxTemp--;
	}
	
	//set temp labels
	pTempString = (Char*)MemPtrNew(5);
	numFormat = (NumberFormatType)PrefGetPreference(prefNumberFormat);
	
	if(g_prefs.tempUnits==1)
		pString = SysStringByIndex(TemperaturesStringList,maxTemp,pTempString,5);
	else //presumable g_prefs.tempUnits==2
	{
		if(numFormat==nfPeriodComma || numFormat==nfSpaceComma || numFormat==nfApostropheComma)
			pString = SysStringByIndex(CelsiusTemperaturesCommStringList,maxTemp,pTempString,5);		
		else
			pString = SysStringByIndex(CelsiusTemperaturesStringList,maxTemp,pTempString,5);
	}
	pString++; //take off the 9
	SetLabel(TempChartToptempLabel,pString, atLeastOneTemp);
	
	if( (maxTemp-minTemp)/2 + minTemp > 0)
	{
		if(g_prefs.tempUnits==1)
			pString = SysStringByIndex(TemperaturesStringList,(maxTemp-minTemp)/2 + minTemp,pTempString,5);
		else //presumable g_prefs.tempUnits==2
		{
			if(numFormat==nfPeriodComma || numFormat==nfSpaceComma || numFormat==nfApostropheComma)
				pString = SysStringByIndex(CelsiusTemperaturesCommStringList,(maxTemp-minTemp)/2 + minTemp,pTempString,5);
			else
				pString = SysStringByIndex(CelsiusTemperaturesStringList,(maxTemp-minTemp)/2 + minTemp,pTempString,5);
		}
		pString++; //take off the the first digit
		SetLabel(TempChartMiddleTempLabel,pString, atLeastOneTemp);
	}
	
	if(minTemp > 0)
	{
		if(g_prefs.tempUnits==1)
			pString = SysStringByIndex(TemperaturesStringList,minTemp,pTempString,5);
		else //presumable g_prefs.tempUnits==2
		{
			if(numFormat==nfPeriodComma || numFormat==nfSpaceComma || numFormat==nfApostropheComma)
				pString = SysStringByIndex(CelsiusTemperaturesCommStringList,minTemp,pTempString,5);
			else
				pString = SysStringByIndex(CelsiusTemperaturesStringList,minTemp,pTempString,5);
		}
		pString++; //take off the 9
		SetLabel(TempChartBottomTempLabel,pString, atLeastOneTemp);
	}
	
	err = MemPtrFree(pTempString);
	
	tempHeight = (rP.extent.y - 10)/float(maxTemp-minTemp);//height of Gadget; subtract 8 to create top (3) and bottom (7) buffer space
	
	//set back to ObjectFill for remaining items which are in gadgets
	if(colorEnabled)
		WinSetBackColor(UIColorGetTableEntryIndex(UIObjectFill));
	
	//draw points
	prevX=200;
	prevY=200;
	prevOpenDotToDraw = false;
	thisOpenDotToDraw = false;
	phaseFill = 0;
	
	//if this is the first time
	//increase start date for scroll
	DateAdjust(&chartStartDate,6*scrollNumber);
	if(scrollNumber)
		minusMore = true;
	else
		minusMore = false;
		
	//find out how many days we need to plot based on adjusted chartStartDate
	nextCycleExists = false;
	cycle = CycleQueryCycle(cycleIndex + 1);
	if(cycle) //if another cycle, difference between start days
	{
		nextCycleStart = cycle->cycleStart;
		dayDiff = DateToDays(nextCycleStart)-DateToDays(chartStartDate);
		CycleReleaseCycle();
		nextCycleExists = true;
	}
	else //otherwise, find date of last day record
	{
		itemIndex = DataGetCount() - 1; //last record
		item = DataQueryData(itemIndex);
		dayDiff = DateToDays(item->recDate) - DateToDays(chartStartDate);
		DataReleaseData();
	}

	FindRecordFromDate(chartStartDate, &itemIndex, NULL, NULL);

	while(true)
	{
		item = DataQueryData(itemIndex);
		if(!item)
			break;
		if(DateTypeCmp(item->recDate,nextCycleStart)==0)
		{
			DataReleaseData();
			break;
		}
		
		currentDiff = DateToDays(item->recDate)-DateToDays(chartStartDate);
		//if break at day 28 and display "more"
		//Because this is using dayDiff to decide whether or not to display day 29,
		//and ScrollNumber in ChartInit checks for more data, there can be a mismatch
		//between the two.  Maybe somewhat complicated to fix, so currently left alone
		if (currentDiff > 28 || (currentDiff==28 && dayDiff>28))//ie will plot day 29
		{
			DataReleaseData();

			oldFont = FntSetFont(stdFont);
			WinDrawChars(">",1,rP.topLeft.x + 28*dayWidth + 1,rP.topLeft.y + 33);
			WinDrawChars(">",1,rP.topLeft.x + 28*dayWidth + 1,rP.topLeft.y + 43);
			WinDrawChars(">",1,rP.topLeft.x + 28*dayWidth + 1,rP.topLeft.y + 53);
			WinDrawChars(">",1,rP.topLeft.x + 28*dayWidth + 1,rP.topLeft.y + 63);
			FntSetFont(oldFont);
			
			plusMore = true;
		
			break;
		}
		else
			plusMore = false;
		
 		if (currentDiff == 0 && minusMore)
		{	
			DataReleaseData();
			itemIndex++;
		}
		else
		{ //end of this is the very bottom of the while
		
		//check to see if I missed some days and fill in the phase
		while(phaseFill < currentDiff)
		{
			phaseDate = chartStartDate;
			DateAdjust(&phaseDate,phaseFill);
			//need to release item so I can call Determine Phase
			DataReleaseData();
			phase = DeterminePhase(phaseDate, itemIndex, false, true, false, NULL, true, NULL);
			phaseStor[phaseFill] = phase;
			heartStor[phaseFill] = 0;
			//pick item back up
			item = DataQueryData(itemIndex);
			x = phaseFill * dayWidth;	
			if (phaseFill != 0 || (phaseFill==0 && !minusMore))
				DrawPhase(x,y,phase);
			phaseFill++;
		}
		//increase so ready for next comparison
		phaseFill++;
		
		//find x
		x = currentDiff * dayWidth;	
		
		//had to move this up so that prevPhase is correct
		focalDate = item->recDate;
		DataReleaseData();
		phase = DeterminePhase(focalDate, itemIndex, true, true, false, NULL, true, NULL);
		phaseStor[phaseFill-1] = phase;
		//pick item back up
		item = DataQueryData(itemIndex);
		heartStor[phaseFill-1] = item->sex;

		if( item->basalTemp !=0 ) 
		{	
		
			//use value instead of raw number so I can insure doesn't exceed limits
			value = item->basalTemp;
			if(g_prefs.tempUnits==2 && value > numberOfCelsiusTemps)
				value = numberOfCelsiusTemps;	

			//find y
			y = (UInt8)((value - minTemp) * tempHeight);
				
			//Draw
			DrawDot(x,y,1,0);
				
			if(g_prefs.timeAdjustMode == 0 || g_prefs.timeAdjustMode == 1)
			{
				//time adjustments of 1/10 F per half hour
				tempAdjust = item->time - 4; //so that entry of 4 is 0 adjustment
				if(g_prefs.timeAdjustMode == 1 && g_prefs.tempUnits==1) //half rate in F
					//change time adjustments to 1/10 F per hour
					tempAdjust = tempAdjust/2;				
				if(g_prefs.tempUnits==2) //if in C, then 1/10 C per hour
						tempAdjust = tempAdjust/2;
			}
			else
				tempAdjust = 0;

			//don't plot if +/- 2:00
			if(tempAdjust && item->time < 8 && item->time > 0 && !item->alcohol)  //Jonathan Hough added !item->alcohol to correct double alcohol and time correction problem
			{
				//find y
				y = (UInt8)((value - tempAdjust - minTemp) * tempHeight);
				
				thisOpenDotToDraw = true;
				//Draw
				//DrawDot(x,y,2);	
			}			
			
			//use WinDrawLine and WinDrawGrayLine to connect temps
			//don't connect if alcohol or +/- 2:00
			if(prevX != 200 && item->time < 8 && item->time > 0 && !item->alcohol)
			{
				WinDrawLine(prevX + rP.topLeft.x + 2, rP.extent.y + rP.topLeft.y-prevY + 2 - 8,
					x + rP.topLeft.x + 2, rP.extent.y + rP.topLeft.y - y + 2 - 8);
			}

			//be sure to adjust a few points so line stays outside open circles
			if(prevOpenDotToDraw)
			{				
				//Draw
				DrawDot(prevX,prevY,2,prevPhase);	
			}
					
			//don't store if +/- 2:00, or alcohol
			if(item->time < 8 && item->time > 0 && !item->alcohol)
			{
				//move down info
				prevOpenDotToDraw = thisOpenDotToDraw;
				thisOpenDotToDraw = false;

				prevX = x;
				prevY = y;
				prevPhase = phase;
			}
	
		}
			
		if(g_prefs.chartDisplay==0) //show cervix position
		{
			if( item->cervix !=0 ) 
			{		
				//find y
				y = (item->cervix) * 3;
				
				//Draw
				DrawBar(x,y,&rCervix,1);			
			}
		}
		else //g_prefs.chartDisplay==1; show hormone test
		{
			if( item->LHTest !=0 ) 
			{		
				//find y
				y = (item->LHTest) * 3;
				switch(item->LHTest)
				{
				case 1: //- or L
					y = 3;
					break;
				
				case 2: //+ or P
					y = 9;
					break;
									
				case 3: // H
					if(g_prefs.hormoneTest == 1)//clearplan
						y = 6;
					else //just LH Test so keep at low level
						y = 3;
					break;
				
				default:
					break;
				
				}
				
				//Draw
				DrawBar(x,y,&rCervix,1);			
			}
		
		}
			
		if( item->fluidSensation >= 4 && item->fluidSensation != 50 ) 
		{				
			//find y
			if(g_prefs.fluidIndicator == 0 || g_prefs.fluidIndicator == 2)	//classic double
			{
				y = (item->fluidSensation - 3) * 3;
				switch(item->fluidSensation)
				{

				case 13:
				case 12:
				case 4:
					y = 3;
					break;
				
				case 15:
				case 16:
				case 5:
					y = 6;
					break;
					
				case 18:
				case 6:
					y = 9;
					break;
				
				default:
					y = 0;
					break;
				}
			}
			else //Marquette model
			{
				switch(item->fluidSensation)
				{
				case 4: //1: dry
					y = 3;
					break;
					
				case 12: //2: not dry
					y = 4;
					break;
	
				case 13: //3:
					y = 5;
					break;

				case 5: //4: moist
					y = 6;
					break;
				
				case 15: //5:
					y = 7;
					break;
				
				case 16: //6:
					y = 8;
					break;

				case 6: //7:
					y = 9;
					break;

				case 18: //8:
					y = 10;
					break;

				default:
					y = 0;
					break;
				}
			}
			//Draw
			DrawBar(x,y,&rSensation,1);			
		}
		else if (item->fluidSensation != 0 && item->fluidSensation != 50)
		{
			//find y
			if(item->fluidSensation == 1)
				y = (3) * 3;
			else if(item->fluidSensation == 2)
				y = (2) * 3;
			else if(item->fluidSensation == 3)
				y = (1) * 3;
				
			//Draw
			DrawBar(x,y,&rSensation,2);				
		}

		if( item->fluidColor != 0 && (g_prefs.fluidIndicator == 0 || g_prefs.fluidIndicator == 2))
		{				
			//find y
			y = (item->fluidColor) * 2;
				
			//Draw
			DrawBar(x,y,&rColor,1);			
		}
		
		DataReleaseData();
		
		
		DrawPhase(x,y,phase);
				
		itemIndex++;
		}//end of else, from the the currentDiff == 0 and minusMore
	}
	
	//Clean up last open dot that may be in buffer
	if(prevOpenDotToDraw)
	{				
		//Draw
		DrawDot(prevX,prevY,2,prevPhase);	
	}
	
	//set current date
	DateSecondsToDate (TimGetSeconds (), &today);
	
	//Finish entering phase information until there is another cycle or today is reached
	//Be sure it doesn't exceed edge of screen
	phaseDate = chartStartDate;
	DateAdjust(&phaseDate,phaseFill);
	if(minusMore)
	{
		oldFont = FntSetFont(stdFont);
		WinDrawChars("<",1,rP.topLeft.x,rP.topLeft.y + 33);
		WinDrawChars("<",1,rP.topLeft.x,rP.topLeft.y + 43);
		WinDrawChars("<",1,rP.topLeft.x,rP.topLeft.y + 53);
		WinDrawChars("<",1,rP.topLeft.x,rP.topLeft.y + 63);
		FntSetFont(oldFont);
	}
	while(DateTypeCmp(phaseDate,today) <= 0)
	{
		//break if reaches next cycle
		if(DateTypeCmp(phaseDate,nextCycleStart) >= 0)
			break;
		//break if "more" is posted
		if( dayDiff > 28 && DateToDays(phaseDate) - DateToDays(chartStartDate) >= 28 )
			break;			
		x = phaseFill * dayWidth;
		//break if reaches edge of screen, this line should not be needed anymore
		if(x > rP.extent.x - dayWidth)
			break;
		phase = DeterminePhase(phaseDate, itemIndex, false, true, false, NULL, true, NULL);

		if (phaseFill != 0 || (phaseFill==0 && !minusMore))
		{
			DrawPhase(x,y,phase);
			phaseStor[phaseFill] = phase;
			heartStor[phaseFill] = 0;
		}

		DateAdjust(&phaseDate,1);
		phaseFill++;
	}
	

	//draw coverline
	cycle = CycleQueryCycle(cycleIndex);
	DrawCoverline(cycle->coverlineStartDate, cycle->coverlineLength, cycle->coverlineTemp, chartStartDate, minTemp, tempHeight);
	CycleReleaseCycle();
	
	
	//finish putting zeros into phaseStor and heartStor
	while(phaseFill <= 28)
	{
		phaseStor[phaseFill] = 0;
		heartStor[phaseFill] = 0;
		phaseFill++;
	}
	
	//return to old font manually for version prior to 3.5
	FntSetFont (origFont);
	if(colorEnabled)
		WinPopDrawState ();
		
	//so that the you don't have to start from the begining, record index into global variable
	if(itemIndex > 0)
		s_currentRecordNumber = itemIndex - 1;  //subtract one in case went past actual number of records

	
	//check to see if Pregnant Form needs to be displayed
	//has to be done here at end instead of in DeterminePhase to aviod double drawing month
	//resulting in odd colors
	if(s_displayPregnancyMessage)
	{
		frmP = FrmGetFormPtr (PregnantForm);
		s_displayedPregnancyMessage = true;
		s_displayPregnancyMessage = false;
		FrmDoDialog (frmP);
		FrmDeleteForm (frmP);
	}

 	return;
}

//static void BriefPreInitialize(RectangleType* rPopUp, RectangleType *rOffscreenFrame, RectangleType* rPopUpFrame)
//{		
//	if(hrEnabled)
//		HRWinGetFramesRectangle(popupFrame,rPopUp,rPopUpFrame);
//	else
//	return;	
//}


//  FUNCTION: BriefInitialize
//
//  DESCRIPTION: Sets things up for Brief pop up
//
//  PARAMETERS:
//
//  RETURNS: true when initialized
static Boolean SECT4 BriefInitialize(Int32 downDiff, FormType *frmP, RectangleType* rPopUp, RectangleType* rPopUpFrame, UInt16 *refNum)
{

	DateType popDate;
	Char* pString;
	Err err;
	
	WinGetFramesRectangle(rectangleFrame,rPopUp,rPopUpFrame);
//	rOffscreenFrame->extent.x = rPopUpFrame->extent.x;
//	rOffscreenFrame->extent.y = rPopUpFrame->extent.y;
//	rOffscreenFrame->topLeft.x = 0;
//	rOffscreenFrame->topLeft.y = 0;


	//initialize controls
	//date of month
	popDate = chartStartDate;
	DateAdjust(&popDate,downDiff);
	pString = (Char*)MemPtrNew(dateStringLength);
	DateToAscii(popDate.month, popDate.day, popDate.year + firstYear,(DateFormatType)PrefGetPreference(prefDateFormat), pString);
	FrmCopyLabel(frmP,TempChartDateLabel,pString);
	err = MemPtrFree(pString);

	//day of cycle
	//only do this if in cycle
	if(phaseStor[downDiff])
	{				
		pString = (Char*)MemPtrNew(maxStrIToALen);
		StrIToA(pString,downDiff + 1 + 6*scrollNumber);
		FrmCopyLabel(frmP,TempChartCycleDayLabel,pString);
		err = MemPtrFree(pString);
	}
	
//	switch(heartStor[downDiff])
//	{
//		default:
//		case 0:
//			break;
//		case 1:	//Y, closed heart
//			FrmNewBitmap(formPP,ClosedHeartBitmapFamily,ClosedHeartBitmapFamily,74,147);
//			break;
//								
//		case 2:	//Protected, open heart
//			FrmNewBitmap(formPP,OpenHeartBitmapFamily,OpenHeartBitmapFamily,74,147);
//			break;
//	}

	if(hrEnabled && heartStor[downDiff])
		SysLibFind(sonySysLibNameHR, refNum);
	return true;
}

//  FUNCTION: BriefShow
//
//  DESCRIPTION: Displays Brief pop up
//
//  PARAMETERS:
//
//  RETURNS: true when shown
static Boolean SECT1 BriefShow(Int32 downDiff, FormType *frmP, RectangleType* rPopUp, BitmapType *pHeart, UInt16 *refNum)
{
//	UInt16 error;

//	WinCopyRectangle(NULL,offscreen,rPopUpFrame,0,0,winPaint);

	//display controls
	WinEraseRectangle(rPopUp,0);
	WinDrawRectangleFrame(rectangleFrame,rPopUp);
	if(phaseStor[downDiff])
	{		
		FrmShowObject(frmP,FrmGetObjectIndex(frmP,TempChartCycleDayLabelLabel));
		FrmShowObject(frmP,FrmGetObjectIndex(frmP,TempChartCycleDayLabel));
	}
	FrmShowObject(frmP,FrmGetObjectIndex(frmP,TempChartDateLabel));
//	switch(heartStor[downDiff])
//	{
//		default:
//		case 0:
//			break;
//		case 1:	//Y, closed heart
//			//FrmShowObject(frmP,FrmGetObjectIndex(frmP,ClosedHeartBitmapFamily));
//			WinDrawBitmap(closedHeart,74,147);
//			break;
//								
//		case 2:	//Protected, open heart
//			//FrmShowObject(frmP,FrmGetObjectIndex(frmP,OpenHeartBitmapFamily));
//			WinDrawBitmap(openHeart,74,147);
//			break;
//	}
	
	if(heartStor[downDiff]==1 || heartStor[downDiff]==2)
		if(hrEnabled)
			HRWinDrawBitmap(*refNum,pHeart,2*(PopUpLeftX + 43),2*(PopUpLeftY + 3));
		else
			WinDrawBitmap (pHeart,PopUpLeftX + 43,PopUpLeftY + 3);
	
	return true;
}

//  FUNCTION: BriefHide
//
//  DESCRIPTION: Hides Brief pop up
//
//  PARAMETERS:
//
//  RETURNS: false when hidden
static Boolean SECT4 BriefHide(Int32 downDiff, FormType *frmP)
{
	//hide controls and bitmap
	if(phaseStor[downDiff])
	{	
		FrmHideObject(frmP,FrmGetObjectIndex(frmP,TempChartCycleDayLabelLabel));
		FrmHideObject(frmP,FrmGetObjectIndex(frmP,TempChartCycleDayLabel));
	}
	FrmHideObject(frmP,FrmGetObjectIndex(frmP,TempChartDateLabel));
//	switch(heartStor[downDiff])
//	{
//		default:
//		case 0:
//			break;
//		case 1:	//Y, closed heart
//			FrmHideObject(frmP,FrmGetObjectIndex(frmP,ClosedHeartBitmapFamily));
//			break;
//								
//		case 2:	//Protected, open heart
//			FrmHideObject(frmP,FrmGetObjectIndex(frmP,OpenHeartBitmapFamily));
//			break;
//	}
	
//	WinCopyRectangle(offscreen,NULL,rOffscreenFrame,rPopUpFrame->topLeft.x,rPopUpFrame->topLeft.y,winPaint);
	
	return false;
}

//  FUNCTION: BriefCleanUp
//
//  DESCRIPTION: Cleans up offscreen window and displayed Bitmap
//
//  PARAMETERS:
//
//  RETURNS:

static void SECT4 BriefCleanUp(Int32 downDiff, BitmapType *pHeart, MemHandle h)
{

	if(heartStor[downDiff]==1 || heartStor[downDiff]==2)
	{
		MemPtrUnlock(pHeart);
		DmReleaseResource(h);
	}

//	WinDeleteWindow(offscreen, false);

	//don't have to delete bitmaps because they are removed in WinDeleteWindow
	//remove bitmap
//	switch(heartStor[downDiff])
//	{
//		default:
//		case 0:
//			break;
//		case 1:	//Y, closed heart
//			FrmRemoveObject (formPP,FrmGetObjectIndex(frmP,ClosedHeartBitmapFamily));
//			break;
//								
//		case 2:	//Protected, open heart
//			FrmRemoveObject (formPP,FrmGetObjectIndex(frmP,OpenHeartBitmapFamily));
//			break;
//	}
	
	
	return;
}


//  FUNCTION: ChartSelectDay
//
//  DESCRIPTION: Gets Pen down information and inverts day.  Also displays brief info popup
//
//  PARAMETERS: eventP contains the penDown information
//				date will return the selected date
//				scroll is how many times the screen is scrolled forward in the current cycle
//
//  RETURNS: true if day was selecter; false if day not selected
Boolean ChartSelectDay(EventType* eventP,DateType* date,Int16* scroll)
{
	Int32 downDiff;
	Int16 penDownX;
	Int16 penDownY;
	Int16 penUpX;
	Int16 penUpY;	
	Boolean penDown;
	RectangleType fullDay;
	RectangleType fullArea;
	UInt8 phase;
//	DateType phaseDate;
//	UInt16 index;
//	Boolean isOldRecord;
//	Boolean dataExists;
//	Boolean beyondMaxIndex;
	Boolean wasInverted = false;
	Boolean detailsShown = false;
	Boolean detailInitialized = false;
//	UInt32	ticksToShow;
	FormType *frmP = NULL; //see if this gets rid of prc-tools error and still works correctly
	RectangleType	rPopUp;
	RectangleType	rPopUpFrame;
//	RectangleType	rOffscreenFrame;
	//i can't get offscreen to pass through to other functions properly, so use all functions
	//that require offscreen in this function
//	WinHandle offscreen; //originally was WinHandle, changed explicitly to pointer
	UInt16 error;
 	BitmapType *pHeart = NULL; //see if this gets rid of prc-tools error and still works correctly
 	MemHandle h = NULL; //see if this gets rid of prc-tools error and still works correctly
 	UInt16 refNum;
 	WinHandle savedScreen = NULL; //see if this gets rid of prc-tools error and still works correctly
	
	rPopUp.topLeft.x = PopUpLeftX;
	rPopUp.topLeft.y = PopUpLeftY;
	rPopUp.extent.x = 100;
	rPopUp.extent.y = 11;

	penDownX = eventP->screenX;
	penDownY = eventP->screenY;

	fullArea.topLeft.y = rP.topLeft.y;
	fullArea.extent.y = rPhase.topLeft.y + rPhase.extent.y  - rP.topLeft.y;
	fullArea.topLeft.x = rP.topLeft.x;
	fullArea.extent.x = rP.extent.x;
	
	//exit if not in Rectangle of interest or no cycle exists
	if (! RctPtInRectangle (penDownX, penDownY, &fullArea) || !chartStartDate.year)
		return false;
		
	downDiff = (penDownX-rP.topLeft.x)/dayWidth;
	//set max to 28 (i.e. 29 days)
	if(downDiff > 27)
		downDiff = 28;
		
	//now change full day to a single day
	fullDay.topLeft.x = rP.topLeft.x + downDiff*dayWidth;
	fullDay.topLeft.y = fullArea.topLeft.y;
	fullDay.extent.y = fullArea.extent.y;
	if(downDiff >= 28)
		fullDay.extent.x = 8;
	else
		fullDay.extent.x = dayWidth;


	phase = phaseStor[downDiff];

	//optional time delay
	//grab time and keep checking
	//ticksToShow = TimGetTicks();
	//adjust to desired trigger time
	//ticksToShow += SysTicksPerSecond()/2; //wait half second

	do 
	{
		PenGetPoint (&penUpX, &penUpY, &penDown);
		
		if (RctPtInRectangle (penUpX, penUpY, &fullDay))
		{
			if (!wasInverted)
			{
				wasInverted = true;
				MonthDrawInversionEffect (&fullDay, 0, phase, wasInverted);
			}
			if (!detailsShown)
			{
				//optional time delay
				//compare time
				//if(TimGetTicks() >= ticksToShow && error == errNone) //if made offscreen buffer
				//{
					if(!detailInitialized)
					{
						//I need to make these in this function, not in Initialize. Otherwise they don't appear to persist or get passed.
						frmP = FrmGetActiveForm();
//						offscreen = WinCreateOffscreenWindow(rPopUpFrame.extent.x,rPopUpFrame.extent.y,genericFormat,&error);
						detailInitialized = BriefInitialize(downDiff, frmP, &rPopUp, &rPopUpFrame, &refNum);
						switch (heartStor[downDiff])
						{
							default:
							case 0:
								break;
		
							case 1:	//Y, closed heart
								if(hrEnabled)
									h = DmGetResource (bitmapRsc, HRClosedHeartBitmapFamily);
								else
									h = DmGetResource (bitmapRsc, ClosedHeartBitmapFamily);
								pHeart = (BitmapType*)MemHandleLock (h);
								break;
							case 2:	//Protected, open heart
								if(hrEnabled)
									h = DmGetResource (bitmapRsc, HROpenHeartBitmapFamily);
								else
									h = DmGetResource (bitmapRsc, OpenHeartBitmapFamily);
								pHeart = (BitmapType*)MemHandleLock (h);
								break;
						}
					}
					
					savedScreen = WinSaveBits(&rPopUpFrame, &error);
					detailsShown = BriefShow(downDiff, frmP, &rPopUp, pHeart, &refNum);
				//}
			}
		}
		else
		{
			if(detailsShown)
			{	
				detailsShown = BriefHide(downDiff,frmP);
				WinRestoreBits(savedScreen, rPopUpFrame.topLeft.x, rPopUpFrame.topLeft.y);
			}

			if (wasInverted)
			{
				wasInverted = false;
				MonthDrawInversionEffect (&fullDay, 0, phase, wasInverted);
			}
		}
		
	} while (penDown);
	
	
	if(detailsShown)
	{
		detailsShown = BriefHide(downDiff,frmP);
		WinRestoreBits(savedScreen, rPopUpFrame.topLeft.x, rPopUpFrame.topLeft.y);
	}
	
	if(detailInitialized)
	{
		BriefCleanUp(downDiff, pHeart, h);
	}
	
	if(wasInverted)
	{
		if(downDiff == 28 && plusMore)
			*scroll = 1;
		else if(downDiff == 0 && minusMore)
			*scroll = -1;
		else
			*scroll = 0;
			
		*date = chartStartDate;
		DateAdjust(date,downDiff);
			
		//otherwise inversion gets stuck on when date is in future
		MonthDrawInversionEffect (&fullDay, 0, phase, false);
	}

	return wasInverted;
}

void ChartChangeCycle(Int8 direction)
{
	Boolean isOldCycle;
	Boolean dataExists;
	UInt16 cycleIndex;
	CycleRecord* cycle;
	
	cycleIndex = s_lastCycleIndex;
	
	switch(direction)
	{
		case -1: 
			isOldCycle = FindCycleFromDate(chartStartDate,&cycleIndex,&dataExists);
			if(cycleIndex>0)
			{
				cycleIndex--;
				cycle = CycleQueryCycle(cycleIndex);
				s_currentDate = cycle->cycleStart;
				CycleReleaseCycle();
				FrmGotoForm(TempChartForm);
			}	
			break;
			
		case 1:
			isOldCycle = FindCycleFromDate(chartStartDate,&cycleIndex,&dataExists);
			if( cycleIndex < CycleGetCount() - 1 )
			{
				cycleIndex++;
				cycle = CycleQueryCycle(cycleIndex);
				s_currentDate = cycle->cycleStart;
				CycleReleaseCycle();
				FrmGotoForm(TempChartForm);
			}
			break;

	}

	return;
}

//used to get info for ChartDeleteEntireCycle and ChartExportCycle
//returns true if cycle data exists
static Boolean SECT4 ChartCycleStartToFinish(UInt16 *cycleIndex, UInt16 *itemStartIndex, UInt16 *itemFinalIndex)
{
	Boolean dataExists;
	Int16 numberOfCycles;
	CycleRecord* nextCycle;

	*cycleIndex = s_lastCycleIndex;

	//we know that if cycle data exists than this will be an old cycle
	FindCycleFromDate(chartStartDate,cycleIndex,&dataExists);
	
	if(dataExists) //this should protect me from errors in which no data has yet been entered
	{
	
		//find out if there is another cycle or if this is the last cycle
		numberOfCycles = CycleGetCount() - 1;
	
		//get index of first day to delete
		FindRecordFromDate(chartStartDate,itemStartIndex,NULL,NULL);

		//get index of last day to delete
		//if there is another cycle, go until date of deleting record is start date of next cycle
		//otherwise go until end of records
		if( *cycleIndex == UInt16(numberOfCycles) || numberOfCycles < 0 ) //last cycle
		{
			*itemFinalIndex = DataGetCount() - 1;
		}
		else //not the last cycle
		{
			// find start date of next cycle, find item for that
			// start date, and backup one itemIndex
			
			nextCycle = CycleQueryCycle(*cycleIndex + 1);
			
			//get index for first record of next cycle
			FindRecordFromDate(nextCycle->cycleStart,itemFinalIndex,NULL,NULL);
			if( *itemFinalIndex > 0 )
				(*itemFinalIndex)--; //although should always be > 0
			
			CycleReleaseCycle();
		}
	}
	
	return dataExists;
}

void ChartDeleteEntireCycle(void)
{
	UInt16 cycleIndex;
	Boolean dataExists;
	UInt16 itemStartIndex;
	UInt16 itemFinalIndex;

	dataExists = ChartCycleStartToFinish(&cycleIndex, &itemStartIndex, &itemFinalIndex);
	
	if(dataExists) //this should protect me from errors in which no data has yet been entered
	{	
		//delete days
		for(UInt16 i=itemStartIndex;i<=itemFinalIndex;i++)
		{
			DataDelete(itemStartIndex);  //don't need to advance because as I delete each item, the next falls into place
		}
	
		//delete cycle record
		CycleDeleteCycle(cycleIndex);
	
	//shouldn't need to recalculate anything because there should be no new info
	//in any cycle, just a longer cycle if there is one before.
	
	}

	return;
}


void ChartExportCycle(void)
{
	UInt16 cycleIndex;
	Boolean dataExists;
	UInt16 itemStartIndex;
	UInt16 itemFinalIndex;
	
	dataExists = ChartCycleStartToFinish(&cycleIndex, &itemStartIndex, &itemFinalIndex);

	if(dataExists) //this should protect me from errors in which no data has yet been entered
	{
		//turn off Pregnant Message to prevent screen error when exporting Pregnant cycle that has not yet been viewed.
		s_displayedPregnancyMessage = true;
		
		if(ExportKey(cycleIndex, itemStartIndex, itemFinalIndex))
			FrmAlert(ExportCompleteAlert);
	}
	return;
}