//    Copyright (C) 2003 Chad Brassil
//    This file is part of NFP.
//
//    NFP is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Foobar is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <PalmOS.h>
#include <SysEvtMgr.h>

#include "NFP.h"
#include "NFPRsc.h"


static void SECT2 PreferencesFormInit(FormType * frmP)
{
	ControlType *ctlP;

	//always start with methods
    GetObjectPtr(ctlP,PreferencesMethodsPushButton);
    CtlSetValue(ctlP,1);
	//Fill in current record information into form
	SetPreferencesToForm();
}

static void SECT2 PreferencesPresets(UInt8 presetvalue)
{
	ControlType *ctlP;
	ListType *lstP;
	UInt8 value;
	
	switch(presetvalue)
	{
		case 1: //default
			GetObjectPtr(lstP,PreferencesTempUnitsList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempUnitsPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesHormoneTestList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesHormoneTestPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesChartDisplayList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesChartDisplayPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesTempMethodList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesPostPeakDaysList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTimeAdjustModePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));		
			break;
		
		case 2: //MM1
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesHormoneTestList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesHormoneTestPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesChartDisplayList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesChartDisplayPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
			value = 1; //half rate
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTimeAdjustModePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));	
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			//no need to select coverline in this setting
		
			break;

		case 3: //MM2
			GetObjectPtr(lstP,PreferencesPostPeakDaysList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 0;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesHormoneTestList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesHormoneTestPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesChartDisplayList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesChartDisplayPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
			value = 1; //half rate
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTimeAdjustModePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));	
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			//no need to select coverline in this setting
		
			break;
		
		case 4: //MM3
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesHormoneTestList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesHormoneTestPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesChartDisplayList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesChartDisplayPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
			value = 1; //half rate
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTimeAdjustModePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));	
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTempMethodList);
			value = 0; //coverline (note: 0 in list, but 1 in g_prefs)
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			break;
	
		case 6: //CCL B
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesPostPeakDaysList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 2;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTempMethodList);
			value = 5; //overall (note 5 in list, but 6 in g_prefs)
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			break;

		case 7: //CCL R
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesPostPeakDaysList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 2;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTempMethodList);
			value = 4; //strong (note 4 in list, not 5 in g_prefs)
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			break;

		case 5: //CCL C
		case 8: //CCL A
			GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

			GetObjectPtr(lstP,PreferencesPostPeakDaysList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesFluidIndicatorList);
			value = 2;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesRoetzerRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesDryDaysRuleList);
			value = 1;
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
			
			GetObjectPtr(lstP,PreferencesTempMethodList);
			value = 3; //full thermal (note 3 in list, not 4 in g_prefs)
			LstSetSelection(lstP,value);
			GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
			CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
			break;

		case 0: //custom
		default:
			break;
	}
	

}


Boolean PreferencesFormHandleEvent(EventType * eventP)
{
    Boolean handled = false;
    FormType * frmP;
    UInt16 objectIndex;
   	ControlType *ctlP;
	ListType *lstP;
	UInt8 value;

    switch (eventP->eType) 
        {
        case frmOpenEvent:
            frmP = FrmGetActiveForm();
            PreferencesFormInit(frmP);
            FrmDrawForm(frmP);

            handled = true;
            break;
                         
        case frmUpdateEvent:
            // To do any custom drawing here, first call 
            // FrmDrawForm(), then do your drawing, and 
            // then set handled to true.
            break;
            
        case ctlSelectEvent:
	        switch (eventP->data.ctlSelect.controlID)
        	{
        		case PreferencesMethodsPushButton:
	        		frmP = FrmGetActiveForm();
					//turn off rules
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempMethodLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesPostPeakDaysLabel);
					FrmHideObject(frmP,objectIndex);					
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFactorsForPostPeakLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRuleLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesDryDaysRuleLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTimeAdjustModeLabel);
					FrmHideObject(frmP,objectIndex);					
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempMethodPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesPostPeakDaysPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFactorsForPostPeakPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRulePopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesDryDaysRulePopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRulePopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTimeAdjustModePopTrigger);
					FrmHideObject(frmP,objectIndex);
				
					//turn on methods
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempUnitsLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempUnitsPopTrigger);
					FrmShowObject(frmP,objectIndex);					
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFluidIndicatorPopTrigger);
					FrmShowObject(frmP,objectIndex);										
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFluidIndicatorLabel);
					FrmShowObject(frmP,objectIndex);					
					objectIndex = FrmGetObjectIndex(frmP,PreferencesHormoneTestPopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesHormoneTestLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesChartDisplayPopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesChartDisplayLabel);
					FrmShowObject(frmP,objectIndex);						
										
        			handled = true;        		
        			break;
        			
        	case PreferencesRulesPushButton:
	        		frmP = FrmGetActiveForm();

					//turn off methods
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempUnitsLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempUnitsPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFluidIndicatorPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFluidIndicatorLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesHormoneTestPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesHormoneTestLabel);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesChartDisplayPopTrigger);
					FrmHideObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesChartDisplayLabel);
					FrmHideObject(frmP,objectIndex);			
										
					//turn on rules
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempMethodLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesPostPeakDaysLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFactorsForPostPeakLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRuleLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesDryDaysRuleLabel);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTimeAdjustModeLabel);
					FrmShowObject(frmP,objectIndex);					
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTempMethodPopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesPostPeakDaysPopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesFactorsForPostPeakPopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRulePopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesDryDaysRulePopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesRoetzerRulePopTrigger);
					FrmShowObject(frmP,objectIndex);
					objectIndex = FrmGetObjectIndex(frmP,PreferencesTimeAdjustModePopTrigger);
					FrmShowObject(frmP,objectIndex);
				
        			handled = true;        		
        			break;	

        		case PreferencesOKButton:
        			//manages data saving and deleting
        			GetPreferencesFromForm();

        			//recalculate for current cycle
        			CalcTemp ();
					CalcBillings();

        			//returns to main form
        	        GoToView();
        			handled = true;        		
        			break;
        			
        		case PreferencesCancelButton:
        			//ignores any data entry and returns to main form
        			GoToView();
        			handled = true;
        			break;
        		
        		//list of options involved with Marquette Model presets, defaults, and CCL
        		case PreferencesFluidIndicatorPopTrigger:
        		case PreferencesTempMethodPopTrigger:
        		case PreferencesFactorsForPostPeakPopTrigger:
        		case PreferencesRoetzerRulePopTrigger:
         		case PreferencesDryDaysRulePopTrigger:
        				GetObjectPtr(lstP,PreferencesPresetsList);
						value = 0;
						LstSetSelection(lstP,value);
						GetObjectPtr(ctlP,PreferencesPresetsPopTrigger);
						CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
        			break;
        			
        		//list of options involved with defaults only
			case PreferencesTempUnitsPopTrigger:
        				GetObjectPtr(lstP,PreferencesPresetsList);
        				value=LstGetSelection(lstP);
        				if(value == 1)
        				{
						value = 0;
						LstSetSelection(lstP,value);
						GetObjectPtr(ctlP,PreferencesPresetsPopTrigger);
						CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
					}
        			break;	

			//list of options involved with defaults or CCL, but not Marquette
        		case PreferencesPostPeakDaysPopTrigger:
        				GetObjectPtr(lstP,PreferencesPresetsList);
        				value=LstGetSelection(lstP);
        				if(value == 1 || value == 5 || value == 6 || value == 7)
        				{
						value = 0;
						LstSetSelection(lstP,value);
						GetObjectPtr(ctlP,PreferencesPresetsPopTrigger);
						CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
					}
        			break;

			//list of options involved with defaults and Marquette, but not CCL
        		case PreferencesTimeAdjustModePopTrigger:
        		case PreferencesHormoneTestPopTrigger:
        		case PreferencesChartDisplayPopTrigger:
        				GetObjectPtr(lstP,PreferencesPresetsList);
        				value=LstGetSelection(lstP);
        				if(value == 1 || value == 2 || value == 3 || value == 4)
        				{
						value = 0;
						LstSetSelection(lstP,value);
						GetObjectPtr(ctlP,PreferencesPresetsPopTrigger);
						CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
					}
        			break;

     	
        		default:
        			break;
			
			}
			break;

        case popSelectEvent:
	        switch (eventP->data.popSelect.controlID)
        	{
        		//preset selected, set others        	
        		case PreferencesPresetsPopTrigger:
       				GetObjectPtr(lstP,PreferencesPresetsList);
       				value=LstGetSelection(lstP);
        			PreferencesPresets(value);
        			break;
        			
        		default:
        			break;
	        }
			break;
        
        default:
            break;
        }
    
    return handled;
}



void GetPreferencesFromForm( void )
{
	ListType *lstP;
	UInt8 value;
	UInt8 storedValue;

	GetObjectPtr(lstP,PreferencesTempMethodList);
	value=LstGetSelection(lstP);
	switch(value)
	{
		case 0:
			storedValue = 1;
			break;
		case 1:
			storedValue = 2;
			break;
		case 2:
			storedValue = 3;
			break;
		case 3:
			storedValue = 4;
			break;
		case 4:
			storedValue = 5;
			break;
		case 5:
			storedValue = 6;
			break;
		default:
			storedValue = 1;  //to satisfy prc-tools
			break;									
	}
	g_prefs.tempMethod=storedValue;
	
	GetObjectPtr(lstP,PreferencesTempUnitsList);
	value=LstGetSelection(lstP);
	switch(value)
	{
		case 0:
			storedValue = 1;
			break;
		case 1:
			storedValue = 2;
			break;
		default:
			break;									
	}
	g_prefs.tempUnits=storedValue;

	GetObjectPtr(lstP,PreferencesPostPeakDaysList);
	value=LstGetSelection(lstP);
	switch(value)
	{
		case 0:
			storedValue = 3;
			break;
		case 1:
			storedValue = 4;
			break;
		default:
			break;									
	}
	g_prefs.postPeakDays=storedValue;
	
	
	GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
	value=LstGetSelection(lstP);
	switch(value)
	{
		case 0:
			storedValue = 1;
			break;
		case 1:
			storedValue = 2;
			break;
		case 2:
			storedValue = 3;
			break;	
		default:
			break;									
	}
	g_prefs.factorsForPostPeak=storedValue;


	GetObjectPtr(lstP,PreferencesRoetzerRuleList);
	value=LstGetSelection(lstP);
	switch(value)
	{
		case 0:
			storedValue = 0; //don't use
			break;
		case 1:
			storedValue = 1; //auto
			break;	
		case 2:
			storedValue = 3;
			break;
		case 3:
			storedValue = 5;
			break;
		case 4:
			storedValue = 6;
			break;	
		default:
			break;									
	}
	g_prefs.roetzerRule=storedValue;
	
	GetObjectPtr(lstP,PreferencesDryDaysRuleList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.dryDaysRule = storedValue;
	
	GetObjectPtr(lstP,PreferencesFluidIndicatorList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.fluidIndicator = storedValue;
	
	GetObjectPtr(lstP,PreferencesHormoneTestList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.hormoneTest = storedValue;
	
	GetObjectPtr(lstP,PreferencesChartDisplayList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.chartDisplay = storedValue;
	
	GetObjectPtr(lstP,PreferencesPresetsList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.presets = storedValue;
	
	GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
	value=LstGetSelection(lstP);
	storedValue = value;
	g_prefs.timeAdjustMode = storedValue;

}

void SetPreferencesToForm( void )
{
	ControlType *ctlP;
	ListType *lstP;
	UInt8 value;

	GetObjectPtr(lstP,PreferencesTempMethodList);
	switch(g_prefs.tempMethod)
	{
		case 1:
			value = 0;
			break;
		case 2:
			value = 1;
			break;
		case 3:
			value = 2;
			break;
		case 4:
			value = 3;
			break;
		case 5:
			value = 4;
			break;
		case 6:
			value = 5;
			break;
		default:
			value = 0; //to satisfy prc-tools
			break;									
	}
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesTempMethodPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesTempUnitsList);
	switch(g_prefs.tempUnits)
	{
		case 1:
			value = 0;
			break;
		case 2:
			value = 1;
			break;
		default:
			break;									
	}
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesTempUnitsPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
		
	GetObjectPtr(lstP,PreferencesPostPeakDaysList);
	switch(g_prefs.postPeakDays)
	{
		case 3:
			value = 0;
			break;
		case 4:
			value = 1;
			break;
		default:
			break;									
	}
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesPostPeakDaysPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));


	GetObjectPtr(lstP,PreferencesFactorsForPostPeakList);
	switch(g_prefs.factorsForPostPeak)
	{
		case 1:
			value = 0;
			break;
		case 2:
			value = 1;
			break;
		case 3:
			value = 2;
			break;			
		default:
			break;									
	}
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesFactorsForPostPeakPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));


	GetObjectPtr(lstP,PreferencesRoetzerRuleList);
	switch(g_prefs.roetzerRule)
	{
		case 0:
			value = 0;
			break;
		case 1:
			value = 1;
			break;	
		case 3:
			value = 2;
			break;
		case 5:
			value = 3;
			break;
		case 6:
			value = 4;
			break;	
		default:
			break;									
	}
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesRoetzerRulePopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));

	
	GetObjectPtr(lstP,PreferencesDryDaysRuleList);
	value = g_prefs.dryDaysRule;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesDryDaysRulePopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesFluidIndicatorList);
	value = g_prefs.fluidIndicator;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesFluidIndicatorPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesHormoneTestList);
	value = g_prefs.hormoneTest;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesHormoneTestPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesChartDisplayList);
	value = g_prefs.chartDisplay;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesChartDisplayPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesPresetsList);
	value = g_prefs.presets;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesPresetsPopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	GetObjectPtr(lstP,PreferencesTimeAdjustModeList);
	value = g_prefs.timeAdjustMode;
	LstSetSelection(lstP,value);
	GetObjectPtr(ctlP,PreferencesTimeAdjustModePopTrigger);
	CtlSetLabel (ctlP,LstGetSelectionText(lstP,value));
	
	return;
}

void SetSummaryForm( FormType* frmP )
{
	Char *pString;
	UInt16 objectIndex;
	Err err;
	UInt8 numberCalc;
	UInt8 numberInAve;
	Char *ending;
	
	numberCalc = CalcAve(&numberInAve);

	//set Number of Cycle
	objectIndex = FrmGetObjectIndex(frmP,SummaryNumberOfCyclesLabel);
	FrmHideObject(frmP,objectIndex);
	pString = (Char*)MemPtrNew(11);
	StrIToA(pString, numberInAve);
 	ending = (Char*)MemHandleLock (DmGetResource (strRsc, CyclesString));
	StrCat(pString,ending);
	FrmCopyLabel(frmP,SummaryNumberOfCyclesLabel,pString);
	err = MemPtrFree(pString);
	FrmShowObject(frmP,objectIndex);
	MemPtrUnlock(ending);

	//set Cycle Length on form
	objectIndex = FrmGetObjectIndex(frmP,SummaryCycleLengthLabel);
	FrmHideObject(frmP,objectIndex);
	pString = (Char*)MemPtrNew(maxStrIToALen);

	if(numberCalc > 0)
		StrIToA(pString, g_prefs.aveCycleLength);
	else
		StrCopy(pString,"");
	
	FrmCopyLabel(frmP,SummaryCycleLengthLabel,pString);
	err = MemPtrFree(pString);
	FrmShowObject(frmP,objectIndex);
	
	//set Shortest Length on form
	objectIndex = FrmGetObjectIndex(frmP,SummaryShortestCycleLabel);
	FrmHideObject(frmP,objectIndex);
	pString = (Char*)MemPtrNew(maxStrIToALen);

	if(numberCalc > 0)
		StrIToA(pString, g_prefs.shortestCycleLength);
	else
		StrCopy(pString,"");
		
	FrmCopyLabel(frmP,SummaryShortestCycleLabel,pString);
	err = MemPtrFree(pString);
	FrmShowObject(frmP,objectIndex); 
	
	//set Luteal Length on form
	objectIndex = FrmGetObjectIndex(frmP,SummaryLutealLengthLabel);
	FrmHideObject(frmP,objectIndex);
	pString = (Char*)MemPtrNew(maxStrIToALen);

	if(numberCalc > 1)
		StrIToA(pString, g_prefs.aveLutealLength);
	else
		StrCopy(pString,"");
		
	FrmCopyLabel(frmP,SummaryLutealLengthLabel,pString);
	err = MemPtrFree(pString);
	FrmShowObject(frmP,objectIndex);
	
	return;
}


static void SECT2 SetPasswordFormInit()
{
	ControlType *ctlP;
	FieldType *fldP;
	Char *pString;
	Char *pSecondString;
	MemHandle textH;
	Int16 len;

	//Fill in current preferences information into form
    GetObjectPtr(ctlP,SetPasswordEnablePasswordCheckbox);
    CtlSetValue(ctlP,g_prefs.enablePassword);

	if(g_prefs.enablePassword)
	{
		GetObjectPtr(fldP,SetPasswordSetPasswordField);
		//The field has not been set, so I don't need to grab the handle because it will just be null
		pSecondString = &g_prefs.password[0];
		len = StrLen(pSecondString);
		textH = MemHandleNew(len + 1);
		// lock the chunk, write to it
		pString = (Char*) MemHandleLock(textH);
		StrCopy(pString,pSecondString);
		// unlock the chunk.
		MemHandleUnlock(textH);
 		// Update the text in the field.
		FldSetTextHandle (fldP, textH);
		
		GetObjectPtr(fldP,SetPasswordConfirmPasswordField);
		//The field has not been set, so I don't need to grab the handle because it will just be null
		pSecondString = &g_prefs.password[0];
		len = StrLen(pSecondString);
		textH = MemHandleNew(len + 1);
		// lock the chunk, write to it
		pString = (Char*) MemHandleLock(textH);
		StrCopy(pString,pSecondString);
		// unlock the chunk.
		MemHandleUnlock(textH);
 		// Update the text in the field.
		FldSetTextHandle (fldP, textH);
	}
	
	return;
}

//return false if set password and confirm password do not match
static Boolean SECT2 GetPasswordFromForm()
{
	ControlType *ctlP;
	FieldType *fldP;
	Char *pString;
	Char *pSecondString;
	Boolean match = true;
	Int16 compare;

	//Get information from form
    GetObjectPtr(ctlP,SetPasswordEnablePasswordCheckbox);
    g_prefs.enablePassword = CtlGetValue(ctlP);

	if(g_prefs.enablePassword)
	{
		GetObjectPtr(fldP,SetPasswordSetPasswordField);
		pString = FldGetTextPtr(fldP);
		
		GetObjectPtr(fldP,SetPasswordConfirmPasswordField);
		pSecondString = FldGetTextPtr(fldP);
		
		if(pString!=NULL && pSecondString!=NULL)
		{
			compare = StrCompare(pString,pSecondString);
			if(compare==0)
				match = true;
			else
				match = false;
		}
		else if((pString==NULL || *pString==NULL) && (pSecondString==NULL || *pSecondString==NULL))
			match = true;
		else
			match = false;
			
		if(match)
		{
			pSecondString = &g_prefs.password[0];
			if(pString==NULL || *pString==NULL)
				*pSecondString = NULL;
			else
				StrCopy(pSecondString,pString);
		}		
	}
	else
		g_prefs.password[0] = NULL;
		
	return match;
}


Boolean SetPasswordFormHandleEvent(EventType * eventP)
{
    Boolean handled = false;
    FormType * frmP;

    switch (eventP->eType) 
        {
        case frmOpenEvent:
            frmP = FrmGetActiveForm();
            SetPasswordFormInit();
            FrmDrawForm(frmP);

            handled = true;
            break;
                         
        case frmUpdateEvent:
            // To do any custom drawing here, first call 
            // FrmDrawForm(), then do your drawing, and 
            // then set handled to true.
            break;
            
        case ctlSelectEvent:
	        switch (eventP->data.ctlSelect.controlID)
        	{
        		case SetPasswordOKButton:
        			//manages data saving and deleting
        			if(GetPasswordFromForm()) //true is match or not enabled			
        	        	GoToView(); //returns to main form
        	        else
        	        	FrmAlert(PasswordMatchAlert);
        			handled = true;        		
        			break;
        			
        		case SetPasswordCancelButton:
        			//ignores any data entry and returns to main form
        			GoToView();
        			handled = true;
        			break;
        	
        		default:
        			break;
			
			}
			break;

        default:
            break;
        }
    
    return handled;
}